﻿require 'sketchup.rb'
require 'fileutils'

UI.menu("Plugins").add_item("purge_multi_daeE") {

    # 1、先删除之前或者最后一个模型
	# deleteLastModel()

	# 2、开始加载每一个COLLADA dae模型了
	#  没有搞定用ruby选择一个文件夹，只好曲线救国了
	# 2.1 选择一个文件,并获取该文件同目录下的所有同类型文件
	#@file = selectDaeFile()

	# 2.2 获取该dae所在的目录文件同目录下的所有dae文件
	#@folder = getFolder(@file)
	import_folder = selectImportDaefolder()
	break if import_folder==nil
	export_folder = selectExportDaefolder()
	break if export_folder==nil
	#@componentinstances = []
	# 2.3 获取该目录下所有的dae文件
	daeFiles = getDaeFiles(import_folder,".dae")

	# 3 开始处理获取到的dae文件
	purgeDaeFile(daeFiles,import_folder,export_folder)


	# 最后要切换到选择工具集，否则会多出来一个导入的模型
	Sketchup.send_action("selectSelectionTool:")
}

# Purge每一个Dae file
def purgeDaeFile(daeFiles, import_folder,export_folder)
	model = Sketchup.active_model
	
	subName = getDirName(import_folder)
	Dir.chdir(export_folder)  #Changes the current working directory of the process to the given string
    FileUtils.rm_r subName if File.exist?(subName)	
    f=File.new(File.join("C:","record.txt"), "w+")
	
	i = 0
	Dir.mkdir(subName)
	daeFiles.each{|singleDaeFile|
	  begin
		Sketchup::set_status_text("purge " + File.basename(singleDaeFile))

	    status = Sketchup.active_model.definitions.purge_unused
	    if i/50 != 0
		   sleep(10);
		   i = 0;
		end;
	    i = i + 1 	
		# 1、导入dae file
		importDaeFile(singleDaeFile)

		# 2、purge dae model
		purgeModel()

		# 3、导出purge之后的dae文件
		resultFileName = File.join(export_folder,subName,File.basename(singleDaeFile))
		Sketchup.active_model.export(resultFileName, false)

		# 4、删除当前的dae,以方便导入下一个
		deleteLastModel()
	  rescue
	    f.puts(singleDaeFile)
		next
	  end
	}
end#def

# purge dae model
def purgeModel()
	# 1. purge styles
	styles = Sketchup.active_model.styles
	status = styles.purge_unused

	# 2. purge materials 
	materials = Sketchup.active_model.materials
	materials.purge_unused

	# 3. purge definitions
	 definitions = Sketchup.active_model.definitions
	 status = definitions.purge_unused

	# 4. purge layers
	layers = Sketchup.active_model.layers
	status = layers.purge_unused
end#def

# 导入dae file
def importDaeFile(singleDaeFile)
   options_hash = { :triangulated_faces   => true,
                  :doublesided_faces    => false,
                  :edges                => false,
                  :author_attribution   => false,
                  :texture_maps         => true,
                  :selectionset_only    => false,
                  :preserve_instancing  => true }
				  
	model = Sketchup.active_model
	model.import(singleDaeFile,options_hash)
	entities = model.entities
    definitions = model.definitions
    #definition = definitions[0] 
	definitions.each {|definition|
    	transformation = Geom::Transformation.new([0,0,0])
    	componentinstance = entities.add_instance(definition, transformation)
		#@componentinstances.push(componentinstance)
    }

    Sketchup.send_action("selectSelectionTool:")

end#def
#  获取一个文件夹下所有的dae文件
def getDaeFiles(folder,type)
	list = []
	Dir.foreach(folder){|file|
		list << File.join(folder,file) if File.extname(file).downcase == type
        }
    return list
end#def

# 获取一个file所在的目录
def getFolder(file)
	folder = File.dirname(file)
	return folder
end#def

# 选择一个对话框
def selectDaeFile()
	msg = "选择一个dae"
	Sketchup::set_status_text(msg)
	file = UI.openpanel(msg,"COLLADA dae文件","")
	if not file
		puts "取消选择..."
		return nil
	else 
		file = file.tr("\\","/")
		return file
	end#if
end#def

#返回目录名
def getDirName(folder)
    names = folder.split("/")
	return names[names.size-1]
end

#选择导入文件夹
def selectImportDaefolder
    chosen_folder = UI.select_directory(
      title: "请选择一个导入文件夹",
      directory: "D:/"
     )
	 return chosen_folder
end

#选择导出文件夹
def selectExportDaefolder
    chosen_folder = UI.select_directory(
      title: "请选择一个导出文件夹",
      directory: "D:/"
     )
	 return chosen_folder
end

# 删除最后一个模型  #删除的同时purge
def deleteLastModel()
	# model = Sketchup.active_model
	# entities = model.active_entities
	# entities.each { |singleEntity|
	# 	entities.erase_entities singleEntity
	# }
        # Sketchup.file_new
        #Sketchup.send_action('editUndo:')
        #Sketchup.send_action('editUndo:')
        #Sketchup.send_action('editUndo:')
        #UI.messagebox("为什么必须弹个窗口出来，否则Sketchup就会挂...")
	model = Sketchup.active_model
    entities = model.active_entities
    #entities.erase_entities @componentinstances
	#@componentinstances.clear# = []
    entities.erase_entities entities.to_a
	#purgeModel()            #防止意外情况   
end#def